// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// vlastne funkcie pre pracu s Frustum
#include "glFrustum.h"

// .h subor
#include "OGL.h"

// instancia triedy CBMPImage
CBMPImage m_cBMPImage;
BMPIMAGE *m_BMPhf;

// instancia triedy FrustumCulling
FrustumCulling m_FrustumCulling;

// konstruktor *************************************************************
COGL::COGL()
{
 lighting_onoff=1;
 fog_onoff=0;
 normals_onoff=0;
 octtree_onoff=0;
 help_onoff=0;

 rot_x=0.0f; rot_y=0.0f;
}

// destruktor **************************************************************
COGL::~COGL()
{

}

void COGL::PrintStartInfo(char *infotext)
{
 ogl_text.OpenDrawString();
 ogl_text.SetTextColor(0.0f,0.0f,0.0f);
 sprintf(ogl_text.mybuf,infotext);
 ogl_text.DrawString(10.0f,StartInfoPos);
 ogl_text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 StartInfoPos+=20.0f;
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool COGL::gl_initialize(void)
{
 // definicia premennych ***************************************************
 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych materialov
  ogl_material[t_a].amb[0]=1.0f; ogl_material[t_a].amb[1]=1.0f;
  ogl_material[t_a].amb[2]=1.0f; ogl_material[t_a].amb[3]=1.0f;
  ogl_material[t_a].dif[0]=0.6f; ogl_material[t_a].dif[1]=0.6f;
  ogl_material[t_a].dif[2]=0.6f; ogl_material[t_a].dif[3]=1.0f;
  ogl_material[t_a].spe[0]=1.0f; ogl_material[t_a].spe[1]=1.0f;
  ogl_material[t_a].spe[2]=1.0f; ogl_material[t_a].spe[3]=1.0f;
  ogl_material[t_a].amb_dif[0]=0.75f; ogl_material[t_a].amb_dif[1]=0.75f;
  ogl_material[t_a].amb_dif[2]=0.75f; ogl_material[t_a].amb_dif[3]=1.0f;
  ogl_material[t_a].emi[0]=0.0f; ogl_material[t_a].emi[1]=0.0f;
  ogl_material[t_a].emi[2]=0.0f; ogl_material[t_a].emi[3]=1.0f;
  ogl_material[t_a].shi=0.0f;
  ogl_material[t_a].transp=0.0f;
  ogl_material[t_a].sillum[0]=0.0f; ogl_material[t_a].sillum[1]=0.0f;
  ogl_material[t_a].sillum[2]=0.0f; ogl_material[t_a].sillum[3]=1.0f;
 }

 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych svetiel
  ogl_light[t_a].amb[0]=0.5f; ogl_light[t_a].amb[1]=0.5f;
  ogl_light[t_a].amb[2]=0.5f; ogl_light[t_a].amb[3]=1.0f;
  ogl_light[t_a].dif[0]=0.75f; ogl_light[t_a].dif[1]=0.75f;
  ogl_light[t_a].dif[2]=0.75f; ogl_light[t_a].dif[3]=1.0f;
  ogl_light[t_a].spe[0]=1.0f; ogl_light[t_a].spe[1]=1.0f;
  ogl_light[t_a].spe[2]=1.0f; ogl_light[t_a].spe[3]=1.0f;
  ogl_light[t_a].pos[0]=5000.0f; ogl_light[t_a].pos[1]=200.0f;
  ogl_light[t_a].pos[2]=-5000.0f; ogl_light[t_a].pos[3]=1.0f;
  ogl_light[t_a].spot[0]=0.0f;
  ogl_light[t_a].spot[1]=0.0f;
  ogl_light[t_a].spot[2]=-1.0f;
 }

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL renderovacich parametrov *****************************
 glClearColor(0.75f,0.75f,0.25f,0.5f); // zasobnik farieb bude vymazavany zltou farbou
 glClearDepth(1.0f);                   // zasobnik hlbky bude vymazavany nastavenim na 1.0

 // nastavenie parametrov 1. svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_light[0].pos);
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 glEnable(GL_LIGHT0);

 glDepthFunc(GL_LEQUAL);  // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane body objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_material[0].amb_dif);

 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // osvetlenie textur alias modulate
 //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 ogl_fogColor[0]=0.75f; ogl_fogColor[1]=0.75f;
 ogl_fogColor[2]=1.0f; ogl_fogColor[3]=1.0f;
 glFogi(GL_FOG_MODE,GL_LINEAR);      // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_fogColor); // farba hmly
 glFogf(GL_FOG_DENSITY,0.1f);        // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);   // dalsie nastavenia
 glFogf(GL_FOG_START,2000.0f);       // pociatok viditelnosti hmly
 glFogf(GL_FOG_END,4000.0f);         // vzdialenost max. hmly
 if (fog_onoff) glEnable(GL_FOG);									// povolenie hmly

 // zapnutie poli vrcholov, normal, koordinatov textur
 //glEnableClientState(GL_VERTEX_ARRAY);
 //glEnableClientState(GL_NORMAL_ARRAY);
 //glEnableClientState(GL_TEXTURE_COORD_ARRAY);

 // antialiasing ciar alias smoothline
 //glEnable(GL_LINE_SMOOTH);
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);

 // funkcia pre vypocet priesvitnosti
 //glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 //glEnable(GL_BLEND); // zapnutie vypoctu priesvitnosti
 //glLineWidth(1.5);

 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // zapnutie texturovania
 glEnable(GL_TEXTURE_2D);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
 StartInfoPos=10.0f;

 // inicializacia vypisovania OpenGL textu
 if (ogl_text.text_initialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }

 PrintStartInfo("Inicializacia OpenGL... OK");

 char fname[128]; // ulozenie cesty a mena nacitavaneho suboru

 PrintStartInfo("Vytvorenie zameriavacieho kriza...");

 // nacitanie obrazku zameriavacieho kriza
 strcpy(fname,"data/"); strcat(fname,"/"); strcat(fname,"crosshair1.bmp\0");
 if (ogl_texture.LoadCrosshairTexture(fname)) {
  fprintf(stderr,"Chyba nacitania obrazka zameriavacieho kriza!\n"); return(1);
 }

 PrintStartInfo("Vytvorenie skyboxu...");

 // nacitanie textur skyboxu
 if (ogl_object.obj_skybox_init("skybox")) {
  fprintf(stderr,"Chyba nacitania textur pre skybox!\n"); return(1);
 }

 PrintStartInfo("Nacitanie vyskovej mapy...");

 // nahratie bitmapy-vyskovej mapy terenu
 strcpy(fname,"data/"); strcat(fname,"terrain"); strcat(fname,"/");
 strcat(fname,"map1_height.bmp\0");
 m_BMPhf=m_cBMPImage.open_bitmap(fname);
 if (!m_BMPhf) {
  fprintf(stderr,"Chyba nacitania vyskovej mapy!\n"); return(1);
 }

 PrintStartInfo("Vytvorenie terenu podla vyskovej mapy...");

 // vytvorenie terenu podla vyskovej mapy
 if (ogl_terrain.terrain_create(m_BMPhf->data)) {
  fprintf(stderr,"Chyba pripravy terenu!\n"); return(1);
 }
 // uvolnenie pamate pouzitej pre vyskovu mapu
 m_cBMPImage.close_bitmap(m_BMPhf);

 PrintStartInfo("Vytvorenie oktanoveho stromu pre teren...");

 // vytvorenie oktanoveho stromu
 if (m_OctTree.Otree_create(ogl_terrain.m_glTriangle.GetTriangles(),
                            ogl_terrain.m_glTriangle.GetTriangleArray())) {
  fprintf(stderr,"Chyba pripravy oktanoveho stromu!\n");
  return(1);
 }

 PrintStartInfo("Nacitanie textur...");

 strcpy(fname,"data/"); strcat(fname,"textures"); strcat(fname,"/");
 strcat(fname,"crate0.bmp\0");
 if (ogl_texture.LoadTexture(0,fname)) {
  fprintf(stderr,"Chyba nacitania textury crate0!\n"); return(1);
 }
 strcpy(fname,"data/"); strcat(fname,"textures"); strcat(fname,"/");
 strcat(fname,"crate1.bmp\0");
 if (ogl_texture.LoadTexture(1,fname)) {
  fprintf(stderr,"Chyba nacitania textury crate1!\n"); return(1);
 }

 ogl_ext.Ext_init();

 PrintStartInfo("OK");

 // vytvorene pole trojuholnikov sa odovzda kamere pre buduce testovanie
 // kolizii
 //ogl_camera[0].cam_triangle_array=ogl_terrain.m_glTriangle.GetTriangleArray();

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 glClearColor(0.5f,0.6f,0.75f,0.5f); // zasobnik farieb bude vymazavany modrou farbou

 return(0);
}

// vykreslenie OpenGL sceny ************************************************
GLubyte COGL::gl_draw(void)
{
 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glMultMatrixf(ogl_camera[0].matrix);

 // vykreslenie skyboxu
 ////ogl_object.obj_skybox_draw();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glTranslatef(ogl_camera[0].posx,ogl_camera[0].posy,ogl_camera[0].posz);

 // transformacia polohy svetla
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_light[0].pos);

 // ulozenie aktualnej matice do zasobnika matic
 glPushMatrix();

 // kreslenie z oktanoveho stromu, FrustumCulling odstranuje listy stromu
 glBindTexture(GL_TEXTURE_2D,ogl_terrain.terrain_texture_id);
 m_OctTree.Otree_render();

 if (normals_onoff) ogl_terrain.m_glTriangle.DrawNormals();

 // vyber aktualnej matice zo zasobnika matic
 glPopMatrix();

 if (octtree_onoff) {
  // ulozenie aktualnej matice do zasobnika matic
  glPushMatrix();

  glLoadIdentity();

  glRotatef(60.0f,1.0f,0.0f,0.0f);
  glTranslatef(-1500.0f,-2500.0f,-250.0f);
  glScalef(0.3f,0.3f,0.3f);
  m_OctTree.Otree_draw();

  // vyber aktualnej matice zo zasobnika matic
  glPopMatrix();
 }

 // ulozenie aktualnej matice do zasobnika matic
 glPushMatrix();

 glTranslatef(5000.0f,500.0f,-5500.0f);
 glRotatef(rot_x,1.0f,0.0f,0.0f); rot_x+=0.05f;
 glRotatef(rot_y,0.0f,1.0f,0.0f); rot_y+=0.05f;
 ogl_ext.MultiTCube(ogl_texture.texture_id[0],ogl_texture.texture_id[1],100.0f);

 // vyber aktualnej matice zo zasobnika matic
 glPopMatrix();

 // vykreslenie zameriavacieho kriza - jednoduchej textury
 ogl_texture.DrawCrosshair(ogl_camera[0].scr_w,ogl_camera[0].scr_h);

 if (help_onoff) {
  // vypis textu - help
  ogl_text.OpenDrawString();
  ogl_text.SetTextColor(1.0f,0.8f,0.0f);

  sprintf(ogl_text.mybuf,"ESC        ukoncenie aplikacie");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-20.0f);
  sprintf(ogl_text.mybuf,"SIPKY      posun dopredu,dozadu,vlavo,vpravo");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-40.0f);
  sprintf(ogl_text.mybuf,"A,Z        posun hore,dole");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-50.0f);
  sprintf(ogl_text.mybuf,"SHIFT      zrychlenie posunu");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-60.0f);
  sprintf(ogl_text.mybuf,"MYS        rotacia v danom smere");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-70.0f);
  sprintf(ogl_text.mybuf,"Q,W        rotacia okolo doprednej osi vlavo,vpravo");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-80.0f);
  sprintf(ogl_text.mybuf,"R          reinicializacia pohladu kamery");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-90.0f);
  sprintf(ogl_text.mybuf,"C          zapnutie/vypnutie detekcie kolizii");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-100.0f);
  sprintf(ogl_text.mybuf,"M          vyplnene trojuholniky/iba hrany trojuholnikov");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-120.0f);
  sprintf(ogl_text.mybuf,"L          zapnutie/vypnutie osvetlenia");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-130.0f);
  sprintf(ogl_text.mybuf,"N          zapnutie/vypnutie zobrazenia normal");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-140.0f);
  sprintf(ogl_text.mybuf,"G          zapnutie/vypnutie hmly");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-160.0f);
  sprintf(ogl_text.mybuf,"F          zmena typu hmly");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-170.0f);
  sprintf(ogl_text.mybuf,"T          zapnutie/vypnutie texturovania");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-190.0f);
  sprintf(ogl_text.mybuf,"O          zapnutie/vypnutie zobrazenia oktanoveho stromu");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-210.0f);
  sprintf(ogl_text.mybuf,"H          zapnutie/vypnutie zobrazenia helpu");
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-230.0f);

  ogl_text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_text.OpenDrawString();
  ogl_text.SetTextColor(1.0f,0.8f,0.0f);
 
  sprintf(ogl_text.mybuf,"x: %6.2f",-ogl_camera[0].posx);
  ogl_text.DrawString(10.0f,30.0f);
  sprintf(ogl_text.mybuf,"y: %6.2f",-ogl_camera[0].posy);
  ogl_text.DrawString(10.0f,20.0f);
  sprintf(ogl_text.mybuf,"z: %6.2f",-ogl_camera[0].posz);
  ogl_text.DrawString(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_text.mybuf,"%i fps",(GLuint) ogl_camera[0].ogl_fps);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-20.0f);

  // vypis textu - pocet vsetkych a orezanych trojuholnikov
  sprintf(ogl_text.mybuf,"vsetkych troj.: %i",m_OctTree.all_tris_count);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-60.0f);
  sprintf(ogl_text.mybuf,"troj. v listoch: %i",m_OctTree.cull_tris_count);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-80.0f);
  sprintf(ogl_text.mybuf,"troj. v scene: %i",m_OctTree.draw_tris_count);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-100.0f);

  // vypis textu - uspesnost vylucenia trojuholnikov pouzitim oktanoveho stromu
  sprintf(ogl_text.mybuf,"uspesnost vylucenia: %i%%\n",(GLuint) ((GLfloat) m_OctTree.draw_tris_count/
                                                                 (GLfloat) m_OctTree.cull_tris_count*100.0f));
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-140.0f);

  // vypis textu - pocet testov pre vylucenie uzlov oktanoveho stromu
  sprintf(ogl_text.mybuf,"pocet testov: %i",m_OctTree.tests_count);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-180.0f);

  ogl_text.SetTextColor(0.0f,1.0f,0.8f);

  // vypis textu - pocet trojuholnikov, s ktorymi sa pocita test kolizie
  sprintf(ogl_text.mybuf,"pocet koliznych troj.: %i",m_OctTree.col_tris_num);
  ogl_text.DrawString(10.0f,ogl_camera[0].scr_h-210.0f);

  ogl_text.CloseDrawString();
 }

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void COGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_state[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_state[0]);

 if (ogl_state[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(100);
}

// zmena parametrov hmly ***************************************************
void COGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_state[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_state[0]);

 if (ogl_state[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_state[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);

 SDL_Delay(100);
}

// zap/vyp texturovania ****************************************************
void COGL::change_TexOnOff(void)
{
 if (glIsEnabled(GL_TEXTURE_2D)) glDisable(GL_TEXTURE_2D);
 else glEnable(GL_TEXTURE_2D);

 SDL_Delay(100);
}

// zap/vyp vykreslovania normal ********************************************
void COGL::change_NormalsOnOff(void)
{
 if (normals_onoff==0) normals_onoff=1; else normals_onoff=0;

 SDL_Delay(100);
}

// zap/vyp vykreslovania oktanoveho stromu *********************************
void COGL::change_OctTreeOnOff(void)
{
 if (octtree_onoff==0) octtree_onoff=1; else octtree_onoff=0;

 SDL_Delay(100);
}

// zap/vyp vypisu helpu ****************************************************
void COGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1; else help_onoff=0;

 SDL_Delay(100);
}

// zap/vyp osvetlenia ******************************************************
void COGL::change_LightingOnOff(void)
{
 if (glIsEnabled(GL_LIGHTING)) glDisable(GL_LIGHTING);
 else glEnable(GL_LIGHTING);

 SDL_Delay(100);
}

// zap/vyp hmly ************************************************************
void COGL::change_FogOnOff(void)
{
 if (glIsEnabled(GL_FOG)) glDisable(GL_FOG);
 else glEnable(GL_FOG);

 SDL_Delay(100);
}

