// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// funkcie pre pracu s FrustumCulling
#include "glFrustum.h"

// funkcie pre pracu s trojuholnikmi
#include "glTriangle.h"

// -------------- matematicke operacie pre vypocet kolizii
#include "3Dmath.h"

m3Dvector myTriangle[3];
m3Dvector myTriangleNormal;
m3Dvector myLine[2];
m3Dvector myTrianglePlanes[3];
float D1,D2,D3;

m3Dmath my_3Dmath;
// -------------- matematicke operacie pre vypocet kolizii

// .h subor
#include "OctTree.h"

FrustumCulling m_FCull;

GLuint TREE_DEPTH=2;

// konstruktor *************************************************************
OctTree::OctTree()
{
 oct_tree=NULL; // rodicovsky list oktanoveho stromu
}

// destruktor **************************************************************
OctTree::~OctTree()
{
 Otree_destroy(); // zrusenie oktanoveho stromu
}

// pridanie listu do oktanoveho stromu *************************************
int OctTree::node_add(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node_level==TREE_DEPTH) { node_level--; return(0); }

 // predna cast ------------------------------------------------------------

 // lava dolna kocka           // zistenie, kolko RAM zaberie strom
 node->node[0]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[0]==NULL) {
  fprintf(stderr,"Error allocating memory for node0!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx; x2=(node->maxx-node->minx)/2.0f;
 y1=node->miny; y2=(node->maxy-node->miny)/2.0f;
 z1=node->minz; z2=(node->maxz-node->minz)/2.0f;
 node->node[0]->minx=x1; node->node[0]->maxx=x1+x2;
 node->node[0]->miny=y1; node->node[0]->maxy=y1+y2;
 node->node[0]->minz=z1; node->node[0]->maxz=z1+z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node front left down\n");
 for (a=0;a<8;a++) node->node[0]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[0]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[0]->node_tris_num=0;

 node_add(node->node[0]); // rekurzia!!!

 // prava dolna kocka          // zistenie, kolko RAM zaberie strom
 node->node[1]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[1]==NULL) {
  fprintf(stderr,"Error allocating memory for node1!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[1]->minx=x2-x1; node->node[1]->maxx=x2;
 node->node[1]->miny=y1;    node->node[1]->maxy=y1+y2;
 node->node[1]->minz=z1;    node->node[1]->maxz=z1+z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node front right down\n");
 for (a=0;a<8;a++) node->node[1]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[1]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[1]->node_tris_num=0;

 node_add(node->node[1]); // rekurzia!!!

 // prava horna kocka          // zistenie, kolko RAM zaberie strom
 node->node[2]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[2]==NULL) {
  fprintf(stderr,"Error allocating memory for node2!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[2]->minx=x2-x1; node->node[2]->maxx=x2;
 node->node[2]->miny=y2-y1; node->node[2]->maxy=y2;
 node->node[2]->minz=z1;    node->node[2]->maxz=z1+z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node front right up\n");
 for (a=0;a<8;a++) node->node[2]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[2]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[2]->node_tris_num=0;

 node_add(node->node[2]); // rekurzia!!!

 // lava horna kocka           // zistenie, kolko RAM zaberie strom
 node->node[3]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[3]==NULL) {
  fprintf(stderr,"Error allocating memory for node3!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=node->minz;                   z2=(node->maxz-node->minz)/2.0f;
 node->node[3]->minx=x1;    node->node[3]->maxx=x1+x2;
 node->node[3]->miny=y2-y1; node->node[3]->maxy=y2;
 node->node[3]->minz=z1;    node->node[3]->maxz=z1+z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node front left up\n");
 for (a=0;a<8;a++) node->node[3]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[3]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[3]->node_tris_num=0;

 node_add(node->node[3]); // rekurzia!!!

 // zadna cast -------------------------------------------------------------

 // lava dolna kocka           // zistenie, kolko RAM zaberie strom
 node->node[4]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[4]==NULL) {
  fprintf(stderr,"Error allocating memory for node4!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[4]->minx=x1; node->node[4]->maxx=x1+x2;
 node->node[4]->miny=y1; node->node[4]->maxy=y1+y2;
 node->node[4]->minz=z2-z1; node->node[4]->maxz=z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node back left down\n");
 for (a=0;a<8;a++) node->node[4]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[4]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[4]->node_tris_num=0;

 node_add(node->node[4]); // rekurzia!!!

 // prava dolna kocka          // zistenie, kolko RAM zaberie strom
 node->node[5]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[5]==NULL) {
  fprintf(stderr,"Error allocating memory for node5!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=node->miny;                   y2=(node->maxy-node->miny)/2.0f;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[5]->minx=x2-x1; node->node[5]->maxx=x2;
 node->node[5]->miny=y1;    node->node[5]->maxy=y1+y2;
 node->node[5]->minz=z2-z1; node->node[5]->maxz=z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node back right down\n");
 for (a=0;a<8;a++) node->node[5]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[5]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[5]->node_tris_num=0;

 node_add(node->node[5]); // rekurzia!!!

 // prava horna kocka          // zistenie, kolko RAM zaberie strom
 node->node[6]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[6]==NULL) {
  fprintf(stderr,"Error allocating memory for node6!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=(node->maxx-node->minx)/2.0f; x2=node->maxx;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[6]->minx=x2-x1; node->node[6]->maxx=x2;
 node->node[6]->miny=y2-y1; node->node[6]->maxy=y2;
 node->node[6]->minz=z2-z1; node->node[6]->maxz=z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node back right up\n");
 for (a=0;a<8;a++) node->node[6]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[6]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[6]->node_tris_num=0;

 node_add(node->node[6]); // rekurzia!!!

 // lava horna kocka           // zistenie, kolko RAM zaberie strom
 node->node[7]=new _tree_node; alloc_mem+=sizeof(_tree_node);
 if (node->node[7]==NULL) {
  fprintf(stderr,"Error allocating memory for node7!\n"); return(1);
 }
 node_level++; // alokacia miesta pre list bola uspesna => nova uroven
 // INFO: informacia o pridani novej urovne
 //fprintf(stderr,"node level: %u\n",node_level);
 // nastavenie rozmerov sublistu (kocky)
 x1=node->minx;                   x2=(node->maxx-node->minx)/2.0f;
 y1=(node->maxy-node->miny)/2.0f; y2=node->maxy;
 z1=(node->maxz-node->minz)/2.0f; z2=node->maxz;
 node->node[7]->minx=x1;    node->node[7]->maxx=x1+x2;
 node->node[7]->miny=y2-y1; node->node[7]->maxy=y2;
 node->node[7]->minz=z2-z1; node->node[7]->maxz=z2;
 // INFO: informacia o pridani uzla
 //fprintf(stderr,"adding node back left up\n");
 for (a=0;a<8;a++) node->node[7]->node[a]=NULL; // vsetky podlisty budu zatial prazdne
 node->node[7]->tris_pointer=NULL; // list zatial nema ziadne trojuholniky
 node->node[7]->node_tris_num=0;

 node_add(node->node[7]); // rekurzia!!!

 node_level--; return(0); // postup o uroven vyssie, pripadne koniec
}

// vytvorenie oktanoveho stromu ********************************************
int OctTree::Otree_create(_TRIANGLE *m_t,GLfloat *t_a)
{
 tris_a=m_t;     // prevzatie zoznamu trojuholnikov
 tris_b=m_t;     // premenna tris_b vzdy ukazuje na zaciatok zoznamu
 tris_array=t_a; // prevzatie odkazu na spojite pole trojuholnikov

 oct_tree=new _tree_node; // vytvorenie rodicovskeho listu oktanoveho stromu
 if (oct_tree==NULL) {
  fprintf(stderr,"Error allocating memory for main node!\n"); return(1);
 }

 alloc_mem=0; alloc_mem+=sizeof(_tree_node); // zistenie, kolko RAM zaberie strom

 oct_tree->minx=0; oct_tree->maxx=0;
 oct_tree->miny=0; oct_tree->maxy=0;
 oct_tree->minz=0; oct_tree->maxz=0;

 all_tris_count=0;
 while (tris_a!=NULL) {
  all_tris_count++;
  // najdenie najmensieho vrcholu vsetkych trojuholnikov
  if ((tris_a->x1)<oct_tree->minx) oct_tree->minx=(tris_a->x1);
  if ((tris_a->x2)<oct_tree->minx) oct_tree->minx=(tris_a->x2);
  if ((tris_a->x3)<oct_tree->minx) oct_tree->minx=(tris_a->x3);

  if ((tris_a->y1)<oct_tree->miny) oct_tree->miny=(tris_a->y1);
  if ((tris_a->y2)<oct_tree->miny) oct_tree->miny=(tris_a->y2);
  if ((tris_a->y3)<oct_tree->miny) oct_tree->miny=(tris_a->y3);

  if ((tris_a->z1)<oct_tree->minz) oct_tree->minz=(tris_a->z1);
  if ((tris_a->z2)<oct_tree->minz) oct_tree->minz=(tris_a->z2);
  if ((tris_a->z3)<oct_tree->minz) oct_tree->minz=(tris_a->z3);

  // najdenie najvacsieho vrcholu vsetkych trojuholnikov
  if ((tris_a->x1)>oct_tree->maxx) oct_tree->maxx=(tris_a->x1);
  if ((tris_a->x2)>oct_tree->maxx) oct_tree->maxx=(tris_a->x2);
  if ((tris_a->x3)>oct_tree->maxx) oct_tree->maxx=(tris_a->x3);

  if ((tris_a->y1)>oct_tree->maxy) oct_tree->maxy=(tris_a->y1);
  if ((tris_a->y2)>oct_tree->maxy) oct_tree->maxy=(tris_a->y2);
  if ((tris_a->y3)>oct_tree->maxy) oct_tree->maxy=(tris_a->y3);

  if ((tris_a->z1)>oct_tree->maxz) oct_tree->maxz=(tris_a->z1);
  if ((tris_a->z2)>oct_tree->maxz) oct_tree->maxz=(tris_a->z2);
  if ((tris_a->z3)>oct_tree->maxz) oct_tree->maxz=(tris_a->z3);

  tris_a=tris_a->next;
 }
 // vsetky podlisty budu zatial prazdne
 for (a=0;a<8;a++) oct_tree->node[a]=NULL;
 // rodicovsky list nema ziadne trojuholniky
 oct_tree->tris_pointer=NULL;
 oct_tree->node_tris_num=0;

 node_level=0; node_add(oct_tree); // zaradenie podlistov do stromu

 // INFO: celkova pamat alokovana pre OctTree
 //fprintf(stderr,"total allocated memory for OctTree: %u\n",alloc_mem);

 free_mem=0; // moze dost k uvolneniu prazdnych listov
 node_level=0; tris_add(oct_tree); // zaradenie trojuholnikov do listov (na poslednu uroven)

 // INFO: uvolnena pamat po listoch, ktore nemaju trojuholniky
 //fprintf(stderr,"memory deleted by empty OctTree nodes: %u\n",free_mem);

 return(0);
}

// rekurzivne vykreslenie oktanoveho stromu ********************************
int OctTree::node_draw(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node->node_draw_bit==1) {
   // predna stena
   glBegin(GL_LINE_LOOP);
    glVertex3f(node->minx,node->miny,node->minz);
    glVertex3f(node->maxx,node->miny,node->minz);
    glVertex3f(node->maxx,node->maxy,node->minz);
    glVertex3f(node->minx,node->maxy,node->minz);
   glEnd();
   // zadna stena
   glBegin(GL_LINE_LOOP);
    glVertex3f(node->minx,node->miny,node->maxz);
    glVertex3f(node->maxx,node->miny,node->maxz);
    glVertex3f(node->maxx,node->maxy,node->maxz);
    glVertex3f(node->minx,node->maxy,node->maxz);
   glEnd();
   // spojovacie ciary
   glBegin(GL_LINES);
    // lava dolna
    glVertex3f(node->minx,node->miny,node->minz);
    glVertex3f(node->minx,node->miny,node->maxz);
    // prava dolna
    glVertex3f(node->maxx,node->miny,node->minz);
    glVertex3f(node->maxx,node->miny,node->maxz);
    // prava horna
    glVertex3f(node->maxx,node->maxy,node->minz);
    glVertex3f(node->maxx,node->maxy,node->maxz);
    // lava horna
    glVertex3f(node->minx,node->maxy,node->minz);
    glVertex3f(node->minx,node->maxy,node->maxz);
   glEnd();
  }
 }

 if (node_level==TREE_DEPTH) { node_level--; return(0); } // vykreslia sa vsetky listy po uroven
 // rekurzia!!!
 node_level++; node_draw(node->node[0]);
 node_level++; node_draw(node->node[1]);
 node_level++; node_draw(node->node[2]);
 node_level++; node_draw(node->node[3]);
 node_level++; node_draw(node->node[4]);
 node_level++; node_draw(node->node[5]);
 node_level++; node_draw(node->node[6]);
 node_level++; node_draw(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// vykreslenie oktanoveho stromu *******************************************
void OctTree::Otree_draw()
{
 glPushAttrib(GL_LIGHTING_BIT|GL_DEPTH_BUFFER_BIT|GL_TEXTURE_BIT|GL_FOG_BIT);
 glDisable(GL_LIGHTING);
 glDisable(GL_DEPTH_TEST);
 glDisable(GL_TEXTURE_2D);
 glDisable(GL_FOG);
 glColor4f(1.0f,1.0f,0.0f,1.0f);

 node_level=0; node_draw(oct_tree);

 glPopAttrib();
}

// zrusenie listov oktanoveho stromu ***************************************
int OctTree::node_del(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node_level==del_level) { // rusi sa konkretny level
   if (node->tris_pointer!=NULL) free(node->tris_pointer); // zrusi sa pole odkazov na trojuholniky
   delete[] node;
   free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
   // INFO: rusi sa uzol
   //fprintf(stderr,"deleting node: %u\n",node_level);
   node_level--; return(0); // postup o uroven vyssie
  }
 }
 else { node_level--; return(0); }

 if (node_level==TREE_DEPTH) { node_level--; return(0); }
 // rekurzia!!!
 node_level++; node_del(node->node[0]);
 node_level++; node_del(node->node[1]);
 node_level++; node_del(node->node[2]);
 node_level++; node_del(node->node[3]);
 node_level++; node_del(node->node[4]);
 node_level++; node_del(node->node[5]);
 node_level++; node_del(node->node[6]);
 node_level++; node_del(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// zrusenie oktanoveho stromu **********************************************
int OctTree::Otree_destroy()
{
 free_mem=0;

 if (TREE_DEPTH>2) node_level=0; del_level=3; node_del(oct_tree); // zrusenie vsetkych listov level3
 if (TREE_DEPTH>1) node_level=0; del_level=2; node_del(oct_tree); // zrusenie vsetkych listov level2
 node_level=0; del_level=1; node_del(oct_tree); // zrusenie vsetkych listov level1

 // zrusenie rodicovskeho listu oktanoveho stromu
 if (oct_tree!=NULL) {
  if (oct_tree->tris_pointer!=NULL) free(oct_tree->tris_pointer); // zrusi sa pole odkazov na trojuholniky
  delete[] oct_tree; oct_tree=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }

 // INFO: informacia o uvolnenej pamati po zruseni oktanoveho stromu
 //fprintf(stderr,"total deleted memory for OctTree: %u\n",free_mem);

 return(0);
}

// pridanie trojuholnikov do listov oktanoveho stromu **********************
int OctTree::tris_add(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node_level==TREE_DEPTH) { // pridava sa iba do poslednej urovne
  node->node_tris_num=0; // spocitanie poctu trojuholnikov listu

  tris_a=tris_b;

  // zistenie poctu trojuholnikov, ktore bude potrebne umiestnit do listu
  while (tris_a!=NULL) {
   c=0;
   // zistenie, ci je trojuholnik aspon 1 vrcholom v liste
   // test x hodnot vrcholov
   if ((((tris_a->x1)>=node->minx)&&((tris_a->x1)<=node->maxx))||
       (((tris_a->x2)>=node->minx)&&((tris_a->x2)<=node->maxx))||
       (((tris_a->x3)>=node->minx)&&((tris_a->x3)<=node->maxx))) c=1;
   // test y hodnot vrcholov
   if (c==1) {
    if ((((tris_a->y1)>=node->miny)&&((tris_a->y1)<=node->maxy))||
        (((tris_a->y2)>=node->miny)&&((tris_a->y2)<=node->maxy))||
        (((tris_a->y3)>=node->miny)&&((tris_a->y3)<=node->maxy))) c=2;
   }
   // test z hodnot vrcholov
   if (c==2) {
    if ((((tris_a->z1)>=node->minz)&&((tris_a->z1)<=node->maxz))||
        (((tris_a->z2)>=node->minz)&&((tris_a->z2)<=node->maxz))||
        (((tris_a->z3)>=node->minz)&&((tris_a->z3)<=node->maxz))) c=3;
   }
   // ake je trojuholnik v liste, zvysi sa pocet trojuholnikov listu
   if (c==3) node->node_tris_num++;

   tris_a=tris_a->next; // dalsi trojuholnik
  }

  // INFO: vypis poctu trojuholnikov v liste
  //fprintf(stderr,"lists tris num: %u\n",node->node_tris_num);

  if (node->node_tris_num!=0) { // v liste budu trojuholniky
   node->tris_pointer=(GLuint *) malloc(node->node_tris_num*sizeof(GLuint));
   if (node->tris_pointer==NULL) {
    fprintf(stderr,"Error allocating memory for tris_pointer!\n"); return(1);
   }

   tris_a=tris_b;

   // vlozenie trojuholnikov do listu
   d=0; e=0; a=0;
   while (tris_a!=NULL) {
    c=0;
    // zistenie, ci je trojuholnik aspon 1 vrcholom v liste
    // test x hodnot vrcholov
    if ((((tris_a->x1)>=node->minx)&&((tris_a->x1)<=node->maxx))||
        (((tris_a->x2)>=node->minx)&&((tris_a->x2)<=node->maxx))||
        (((tris_a->x3)>=node->minx)&&((tris_a->x3)<=node->maxx))) c=1;
    // test y hodnot vrcholov
    if (c==1) {
     if ((((tris_a->y1)>=node->miny)&&((tris_a->y1)<=node->maxy))||
         (((tris_a->y2)>=node->miny)&&((tris_a->y2)<=node->maxy))||
         (((tris_a->y3)>=node->miny)&&((tris_a->y3)<=node->maxy))) c=2;
    }
    // test z hodnot vrcholov
    if (c==2) {
     if ((((tris_a->z1)>=node->minz)&&((tris_a->z1)<=node->maxz))||
         (((tris_a->z2)>=node->minz)&&((tris_a->z2)<=node->maxz))||
         (((tris_a->z3)>=node->minz)&&((tris_a->z3)<=node->maxz))) c=3;
    }
    // ake je trojuholnik v liste, pridam ho do pola
    if (c==3) {
     *(node->tris_pointer+a)=(tris_a->id);

     d+=9; e+=6; a++;
    }

    tris_a=tris_a->next; // dalsi trojuholnik
   }
  }
  else { node_level--; return(1); } // list je potrebne vymazat
  // po vlozeni trojuholnikov do najnizsej urovne nasleduje postup na vyssiu uroven
  node_level--; return(0);
 }

 // rekurzia!!!
 node_level++;
 if (tris_add(node->node[0])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[0]->tris_pointer!=NULL) free(node->node[0]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[0]; node->node[0]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[1])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[1]->tris_pointer!=NULL) free(node->node[1]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[1]; node->node[1]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[2])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[2]->tris_pointer!=NULL) free(node->node[2]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[2]; node->node[2]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[3])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[3]->tris_pointer!=NULL) free(node->node[3]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[3]; node->node[3]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[4])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[4]->tris_pointer!=NULL) free(node->node[4]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[4]; node->node[4]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[5])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[5]->tris_pointer!=NULL) free(node->node[5]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[5]; node->node[5]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[6])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[6]->tris_pointer!=NULL) free(node->node[6]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[6]; node->node[6]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 node_level++;
 if (tris_add(node->node[7])) {
  // list sa vymaze, nakolko v nom nie su ziadne trojuholniky
  if (node->node[7]->tris_pointer!=NULL) free(node->node[7]->tris_pointer); // zrusi sa pole odkazov na priradene trojuholniky
  delete[] node->node[7]; node->node[7]=NULL;
  free_mem+=sizeof(_tree_node); // zistenie, kolko RAM sa uvolni
 }
 // a postupne naspat...
 node_level--; return(0);
}

int OctTree::clear_node_draw_bit(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  node->node_draw_bit=0;
 }

 if (node_level==TREE_DEPTH) { node_level--; return(0); }
 // rekurzia!!!
 node_level++; clear_node_draw_bit(node->node[0]);
 node_level++; clear_node_draw_bit(node->node[1]);
 node_level++; clear_node_draw_bit(node->node[2]);
 node_level++; clear_node_draw_bit(node->node[3]);
 node_level++; clear_node_draw_bit(node->node[4]);
 node_level++; clear_node_draw_bit(node->node[5]);
 node_level++; clear_node_draw_bit(node->node[6]);
 node_level++; clear_node_draw_bit(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// // test viditelnosti listov stromu **************************************
int OctTree::node_test(_tree_node *node) // rekurzivna funkcia!!!
{
 tests_count++;

 if (node!=NULL) {
  if (m_FCull.CubeInFrustum2(node->minx,node->maxx,
                             node->miny,node->maxy,
                             node->minz,node->maxz)) {
   node->node_draw_bit=1;
  }
  else { node->node_draw_bit=0; node_level--; return(0); }
 }

 if (node_level==TREE_DEPTH) { node_level--; return(0); }
 // rekurzia!!!
 node_level++; node_test(node->node[0]);
 node_level++; node_test(node->node[1]);
 node_level++; node_test(node->node[2]);
 node_level++; node_test(node->node[3]);
 node_level++; node_test(node->node[4]);
 node_level++; node_test(node->node[5]);
 node_level++; node_test(node->node[6]);
 node_level++; node_test(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// rekurzivne vykreslenie trojuholnikov v listoch oktanoveho stromu ********
int OctTree::node_render(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node->node_draw_bit==1) {
   if (node_level==TREE_DEPTH) {
    // kreslia sa vsetky trojuholniky listu --------------------------------
    //glVertexPointer(3,GL_FLOAT,0,node->node_tris);
    //glNormalPointer(GL_FLOAT,0,node->node_normals);
    //glTexCoordPointer(2,GL_FLOAT,0,node->node_texcoords);

    //glDrawArrays(GL_TRIANGLES,0,3*node->node_tris_num);

    cull_tris_count+=node->node_tris_num;

    // kreslia sa iba viditelne trojuholniky listu -------------------------
    for (a=0;a<node->node_tris_num;a++) {
     // b=odkaz na konkretny trojuholnik v spojitom poli trojuholnikov
     b=*(node->tris_pointer+a);
     // ak trojuholnik este nebol kresleny, pokracuje sa v teste FustumCulling
     if (*(tris_array+b+39)==0.0f) {
      if (m_FCull.TriangleInFrustum(*(tris_array+b  ),*(tris_array+b+1),*(tris_array+b+2),
                                    *(tris_array+b+3),*(tris_array+b+4),*(tris_array+b+5),
                                    *(tris_array+b+6),*(tris_array+b+7),*(tris_array+b+8))) {
       glBegin(GL_TRIANGLES);
        glTexCoord2f(*(tris_array+b+21),*(tris_array+b+22));
        glNormal3f(*(tris_array+b+12),*(tris_array+b+13),*(tris_array+b+14));
        glVertex3f(*(tris_array+b),*(tris_array+b+1),*(tris_array+b+2));

        glTexCoord2f(*(tris_array+b+23),*(tris_array+b+24));
        glNormal3f(*(tris_array+b+15),*(tris_array+b+16),*(tris_array+b+17));
        glVertex3f(*(tris_array+b+3),*(tris_array+b+4),*(tris_array+b+5));

        glTexCoord2f(*(tris_array+b+25),*(tris_array+b+26));
        glNormal3f(*(tris_array+b+18),*(tris_array+b+19),*(tris_array+b+20));
        glVertex3f(*(tris_array+b+6),*(tris_array+b+7),*(tris_array+b+8));
       glEnd();

       draw_tris_count++;

       // trojuholnik bol vykresleny => dalej sa uz nespracuvava
       *(tris_array+b+39)=1.0f;
      }
     }
    }

    // INFO: rozmer listu oktanoveho stromu
    //fprintf(stderr,"%f\n",node->maxx-node->minx);
   }
  }
  else { node_level--; return(0); }
 }

 if (node_level==TREE_DEPTH) { node_level--; return(0); }
 // rekurzia!!!
 node_level++; node_render(node->node[0]);
 node_level++; node_render(node->node[1]);
 node_level++; node_render(node->node[2]);
 node_level++; node_render(node->node[3]);
 node_level++; node_render(node->node[4]);
 node_level++; node_render(node->node[5]);
 node_level++; node_render(node->node[6]);
 node_level++; node_render(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// vykreslenie oktanoveho stromu *******************************************
void OctTree::Otree_render()
{
 m_FCull.FrustumUpdate();

 node_level=0; clear_node_draw_bit(oct_tree);

 cull_tris_count=0; // pocet trojuholnikov listu
 draw_tris_count=0; // pocet skutocne kreslenych trojuholnikov

 tests_count=0; node_level=0; node_test(oct_tree);

 // INFO: pocet vykonanych testov
 //fprintf(stderr,"tests num: %u\n",tests_num);

 node_level=0; node_render(oct_tree);

 // po vykresleni sa pre vsetky trojuholniky nastavi drawbit na 0 
 b=0;
 for (a=0;a<all_tris_count;a++) {
  *(tris_array+b+39)=0.0f;
  b+=40;
 }
}

// rekurzivne najdenie listu, s ktoreho trojuholnikmi moze byt kamera v kolizii
int OctTree::get_CNode(_tree_node *node) // rekurzivna funkcia!!!
{
 if (node!=NULL) {
  if (node_level==TREE_DEPTH) {
   if ((CPX+10.0f<node->minx)||(CPX-10.0f>node->maxx)||
       (CPY+10.0f<node->miny)||(CPY-10.0f>node->maxy)||
       (CPZ+10.0f<node->minz)||(CPZ-10.0f>node->maxz)) {
     // nic sa nepocita
     // INFO: pocet vyradenych trojuholnikov
     //fprintf(stderr,"out tris num: %u\n",node->node_tris_num);
     out_tris_num+=node->node_tris_num;
   }
   else {
    col_tris_num+=node->node_tris_num;

    for (t_a=0;t_a<node->node_tris_num;t_a++) {
     t_b=*(node->tris_pointer+t_a); // vyber konkretneho trojuholnika zo zoznamu
     // naplnenie "koliznych" premennych udajmi o trojuholniku
     myTriangle[0].x=*(tris_array+t_b  );
     myTriangle[0].y=*(tris_array+t_b+1);
     myTriangle[0].z=*(tris_array+t_b+2);
     myTriangle[1].x=*(tris_array+t_b+3);
     myTriangle[1].y=*(tris_array+t_b+4);
     myTriangle[1].z=*(tris_array+t_b+5);
     myTriangle[2].x=*(tris_array+t_b+6);
     myTriangle[2].y=*(tris_array+t_b+7);
     myTriangle[2].z=*(tris_array+t_b+8);

     myLine[1].x=CPX;
     myLine[1].y=CPY;
     myLine[1].z=CPZ;

     myTriangleNormal.x=*(tris_array+t_b+9 );
     myTriangleNormal.y=*(tris_array+t_b+10);
     myTriangleNormal.z=*(tris_array+t_b+11);

     myTrianglePlanes[0].x=*(tris_array+t_b+27);
     myTrianglePlanes[0].y=*(tris_array+t_b+28);
     myTrianglePlanes[0].z=*(tris_array+t_b+29);
     D1=*(tris_array+t_b+30);
     myTrianglePlanes[1].x=*(tris_array+t_b+31);
     myTrianglePlanes[1].y=*(tris_array+t_b+32);
     myTrianglePlanes[1].z=*(tris_array+t_b+33);
     D2=*(tris_array+t_b+34);
     myTrianglePlanes[2].x=*(tris_array+t_b+35);
     myTrianglePlanes[2].y=*(tris_array+t_b+36);
     myTrianglePlanes[2].z=*(tris_array+t_b+37);
     D3=*(tris_array+t_b+38);

     if (my_3Dmath.CameraInTriangleS(myTriangle,myTriangleNormal,myLine[1],10.0f,
                                     myTrianglePlanes,D1,D2,D3)) {
      // pozicia kamery bude zmenena na zaklade kolizie s trojuholnikom, resp. jeho hranami
      CPX=my_3Dmath.ret_pos.x; CPY=my_3Dmath.ret_pos.y; CPZ=my_3Dmath.ret_pos.z;

      is_collision=1;
     } // if
    } // for
   } // else
  } // if
 } // if
 else { node_level--; return(0); }

 if (node_level==TREE_DEPTH) { node_level--; return(0); }
 // rekurzia!!!
 node_level++; get_CNode(node->node[0]);
 node_level++; get_CNode(node->node[1]);
 node_level++; get_CNode(node->node[2]);
 node_level++; get_CNode(node->node[3]);
 node_level++; get_CNode(node->node[4]);
 node_level++; get_CNode(node->node[5]);
 node_level++; get_CNode(node->node[6]);
 node_level++; get_CNode(node->node[7]);
 // a postupne naspat...
 node_level--; return(0);
}

// detekcia kolizie kamery *************************************************
void OctTree::cam_collision(GLfloat cx,GLfloat cy,GLfloat cz)
{
 is_collision=0; // zatial nie je kolizia

 CPX=cx; CPY=cy; CPZ=cz;

 out_tris_num=0;
 col_tris_num=0;

 node_level=0; get_CNode(oct_tree);
}
