// trieda pre pracu s oktanovym stromom
typedef struct __tree_node { // list oktanoveho stromu
 GLfloat minx,maxx,miny,maxy,minz,maxz; // steny listu (kocky) oktanoveho stromu
 __tree_node *node[8];                  // odkaz na 8 podlistov aktualneho listu
 GLuint *tris_pointer;    // pole odkazov na trojuholniky priradene aktualnemu listu
 GLuint node_tris_num;    // pocet trojuholnikov aktualneho listu
 GLuint node_draw_bit;    // 0 - nekresli sa, 1 - kresli sa
} _tree_node;

class OctTree {
public:
 OctTree();          // konstruktor
 virtual ~OctTree(); // destruktor

 int Otree_create(_TRIANGLE *m_t,GLfloat *t_a); // vytvorenie oktanoveho stromu
 void Otree_draw();                             // vykreslenie oktanoveho stromu
 int Otree_destroy();                           // zrusenie oktanoveho stromu
 void Otree_render();                           // vykreslenie trojuholnikov stromu

 GLuint all_tris_count;  // celkovy pocet trojuholnikov odovzdanych do OctTree
 GLuint cull_tris_count; // pocet kladne otestovanych trojuholnikov oktanoveho stromu
 GLuint draw_tris_count; // pocet realne vykreslovanych trojuholnikov

 GLuint tests_count; // pocet testov na viditelnost listov stromu

 // detekcia kolizie kamery
 void cam_collision(GLfloat cx,GLfloat cy,GLfloat cz);

 GLfloat CPX,CPY,CPZ;  // poloha kamery pocas vypoctu kolizii
 GLubyte is_collision; // indikator kolizie

 GLuint out_tris_num; // pocet trojuholnikov, s ktorymi sa nepocita kolizia
 GLuint col_tris_num; // pocet moznych koliznych trojuholnikov
private:
 _TRIANGLE *tris_a,*tris_b; // ukazovatel na zoznam trojuholnikov
 GLfloat *tris_array;       // ukazovatel na spojite pole trojuholnikov
 _tree_node *oct_tree; // rodicovsky list oktanoveho stromu

 GLuint a,b,c,d,e;          // pomocne premenne
 GLuint t_a,t_b;            // pomocne premenne
 GLfloat x1,x2,y1,y2,z1,z2; // pomocne premenne

 GLuint node_level;    // hlbka oktanoveho stromu
 GLuint del_level;     // hlbka oktanoveho stromu, v ktorej budu zmazane listy

 int node_add(_tree_node *node);  // pridanie listu do oktanoveho stromu
 int node_draw(_tree_node *node); // rekurzivne vykreslenie stromu
 int node_del(_tree_node *node);  // rekurzivne zrusenie listov stromu

 int tris_add(_tree_node *node);     // pridanie trojuholnikov do listov oktanoveho stromu
                                     // pridava sa do poslednej urovne

 int node_test(_tree_node *node);    // test viditelnosti listov stromu
 int node_render(_tree_node *node);  // vykreslenie trojuholnikov ulozenych v listoch oktanoveho stromu
                                     // kresli sa z poslednej urovne

 int clear_node_draw_bit(_tree_node *node); // vymazanie indikatorov klreslenia listov
                                            // iba pre zobrazenie struktury stromu
                                            // v koncovej aplikacii odstranit!!!
 GLuint alloc_mem; // pocitadlo alokovanej pamate
 GLuint free_mem;  // pocitadlo uvolnenej pamate

 // rekurzivne najdenie listu, s ktoreho trojuholnikmi moze byt kamera v kolizii
 int get_CNode(_tree_node *node);
};
